﻿using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace $rootnamespace$
{


	// TODO: Make Project "Com-Visible and -Registered"
	// Project Properties --> Build --> Register for Com-Interop
	// Project Properties --> Application --> Assembly Information... --> Make assembly Com-Visible


/*	//TODO: if no ITabControl interface is provided, in the project, uncomment this section.
	/// <summary>
	/// Interface for Enterprise Architect UserControls
	/// </summary>
	[Guid("$guid1$"),
		InterfaceType(ComInterfaceType.InterfaceIsDual),
		ComVisible(true)]
	public interface ITabControl
	{
		// functions/properties and events can be added as you like	
	}
//*/


	/// <summary>
	/// Class for Enterprise Architect UserControls
	/// </summary>
    [Guid("$guid2$"),

        // This is basically the programmer friendly name
        // for the guid above. We define this because it will
        // be used to instantiate this class. I think this can be
        // whatever you want. Generally it is
        // [assemblyname].[classname]
        ProgId("EAControl.$rootnamespace$.$safeitemname$"),

        // No class interface is generated for this class and
        // no interface is marked as the default.
        // Users are expected to expose functionality through
        // interfaces that will be explicitly exposed by the object
        // This means the object can only expose interfaces we define
        ClassInterface(ClassInterfaceType.AutoDual),

        // Set the default COM interface that will be used for
        // Automation. Languages like: C#, C++ and VB
        // allow to query for interface's we're interested in
        // but Automation only aware languages like javascript do
        // not allow to query interface(s) and create only the
        // default one
        ComDefaultInterface(typeof(ITabControl)),
        ComVisible(true)
    ]
    public partial class $safeitemname$ : UserControl, ITabControl
    {
	
		// functions/properties and events can be added as you like
	
		/// <summary>
		/// Initializes a new instance of the <see cref="$safeitemname$"/> class.
		/// </summary>
        public $safeitemname$()
        {
            InitializeComponent();            
        }
		
		
		// To add this control to EA as dockable window use the following Code		
		/// <summary>
		/// Creates a dockable window for Enterprise Architect using the EAUserTab1-control.
		/// !! Dockable windows can only be added after opening a EAP file !!
		/// </summary>
		/// <param name="repository">The <see cref="EA.Repository"/>.</param>
		/// <param name="title">The title of the window.</param>
		/// <returns>Returns an <see cref="ITabControl"/> interface of the added window.</returns>
		/// <exception cref="System.ApplicationException">if no Enterprise Architect repository was provided.</exception>
		/// <exception cref="System.ApplicationException">if Enterprise Architect could not load/create the control.</exception>
		public static ITabControl CreateDockableWindow(EA.Repository repository, string title)
		{
			if (!object.Equals(repository, null))
			{
				// Addin usercontrol to Enterprise Architect with specified title
				ITabControl tab = (repository.AddWindow(title, "EAControl.$rootnamespace$.$safeitemname$") as ITabControl);
				
				// Checking if control/window could be loaded/created
				if (object.Equals(tab, null))
				{
					throw new System.ApplicationException(string.Format("Enterprise Architect could not addin load dockable window '{0}'.", title));
				}
				return tab;
			}
			throw new System.ApplicationException("No Enterprise Architect repository provided.");
		}

		// To add this control to EA as diagram use the following Code
		/// <summary>
		/// Creates a diagram for Enterprise Architect using the EAUserTab1"-control.
		/// </summary>
		/// <param name="repository">The <see cref="EA.Repository"/>.</param>
		/// <param name="title">The title of the diagram.</param>
		/// <returns>Returns an <see cref="ITabControl"/> interface of the added diagram.</returns>
		/// <exception cref="System.ApplicationException">if no Enterprise Architect repository was provided.</exception>
		/// <exception cref="System.ApplicationException">if Enterprise Architect could not load/create the control.</exception>
		public static ITabControl CreateDiagram(EA.Repository repository, string title)
		{
			if (!object.Equals(repository, null))
			{
				// Addin usercontrol to Enterprise Architect with specified title
				ITabControl tab = (repository.AddWindow(title, "EAControl.$rootnamespace$.$safeitemname$") as ITabControl);
				
				// Checking if control/diagram could be loaded/created
				if (object.Equals(tab, null))
				{
					throw new System.ApplicationException(string.Format("Enterprise Architect could not load addin diagram '{0}'.", title));
				}
				return tab;
			}
			throw new System.ApplicationException("No Enterprise Architect repository provided.");
		}


		/// <summary>
		/// Checks the visibility state of the diagram.
		/// </summary>
		/// <param name="repository">The <see cref="EA.Repository"/>.</param>
		/// <param name="title">The title of the diagram.</param>
		/// <exception cref="System.ApplicationException">if no Enterprise Architect repository was provided.</exception>
		/// <exception cref="System.ApplicationException">if Enterprise Architect returned an unknown diagram state.</exception>
		public static void CheckDiagramState(EA.Repository repository, string title)
		{
			if (!object.Equals(repository, null))
			{
				int state = repository.IsTabOpen(title);
				switch (state)
				{
					case 0:
						System.Windows.Forms.MessageBox.Show("Diagram not Visible");
						return;
					case 1:
						System.Windows.Forms.MessageBox.Show("Diagram opened but not top-most");
						return;
					case 2:
						System.Windows.Forms.MessageBox.Show("Diagram Visible");
						return;
					default:
						throw new System.ApplicationException("Unknown diagram state returned by Enterprise Architect.");
				}
			}
			throw new System.ApplicationException("No Enterprise Architect repository provided.");
		}
    }
}
